<?php

add_action('admin_init', 'cbwpm_options_init' );
add_action('admin_menu', 'cbwpm_options_add_page');
add_action('wp_footer', 'cbwp_footerstuff');

$blogurl=get_bloginfo('wpurl');
$options = get_option('cbm_data');
$cbm_notloggedin='<p><b>You must <a href="'.$blogurl.'/wp-login.php">login</a> to see the rest of this content. Not a member yet? <a href="'.$blogurl.'/wp-login.php?action=register">Register for FREE!</a></b></p>';

$cbm_notpaid='<p><b>You need to be '.$options['cbmemdesc'].' to view this content. <a href="[sales_page]">Click Here to upgrade.</a></b></p>';

$cbm_pitchpage=$options['cbpitchpage'];
$cbm_clickbankname=$options['clickbankname'];
$cbm_clickbankitemno=$options['cbitemno'];


/* Add shortcodes. */
add_shortcode( 'feed', 'members_access_check_shortcode' );
add_shortcode( 'visitor', 'visitor_check_shortcode' );
add_shortcode( 'paid_member', 'paid_members_access_check_shortcode' );
add_shortcode( 'paid_only', 'silentpaid_members_access_check_shortcode' );
add_shortcode( 'clickbank_saleslink', 'clickbank_saleslink_shortcode' );
add_shortcode( 'sales_page', 'salespage_shortcode' );
add_shortcode( 'free_member', 'members_is_user_logged_in_shortcode' );
add_shortcode( 'free_only', 'free_members_access_check_shortcode' );

function cbwp_footerstuff() {
	global $cbm_clickbankname;
	$powerlink='Membership Controlled by <a href="http://yoursalesdomain.com">Plugin Name</a>';
	echo $powerlink;
}

function clickbank_saleslink_shortcode( $attr ) {
	global $user_ID;
	global $blogurl;
    global $cbm_clickbankname;
	global $cbm_clickbankitemno;
	 get_currentuserinfo();
			if (trim($user_ID) !=''){
			$saleslink='http://'.$cbm_clickbankitemno.'.'.$cbm_clickbankname.'.pay.clickbank.net?wpid='.$user_ID;	
			}
			else {
				$saleslink=$blogurl.'/wp-login.php';
			}
	return $saleslink;
}

function salespage_shortcode( $attr ) {
		global $cbm_pitchpage;
		return $cbm_pitchpage;
}

function members_is_user_logged_in_shortcode( $attr, $content = null ) {
	global $cbm_notloggedin;
	/* If it is a feed or the user is not logged in, return nothing. */
	if ( is_user_logged_in() )
		return do_shortcode($content);

	/* Return the content. */
	return do_shortcode($cbm_notloggedin);
}


function visitor_check_shortcode( $atts, $content = null ) {
	 if ( ( !is_user_logged_in() && !is_null( $content ) ) || is_feed() )
		return do_shortcode($content);
	return '';
}


function members_feed_shortcode( $attr, $content = null ) {

	/* If not feed or no content exists, return nothing. */
	if ( !is_feed() || is_null( $content ) )
		return '';

	/* Return the content. */
	return do_shortcode($content);
}



function paid_members_access_check_shortcode( $attr, $content = null ) {
	global $cbm_notpaid;
	if ( current_user_can( 'paidmember' ) )
		return do_shortcode($content);

	/* If the current user has the input role, show the content. */
	elseif ( current_user_can( 'administrator') )
		return do_shortcode($content);

	/* If there is no content, return nothing. */
	elseif ( is_null( $content ) )
		return '';

	/* Return nothing if none of the conditions have been met. */
	
	return do_shortcode($cbm_notpaid);
}

function silentpaid_members_access_check_shortcode( $attr, $content = null ) {
	global $cbm_notpaid;
	if ( current_user_can( 'paidmember' ) )
		return do_shortcode($content);

	/* If the current user has the input role, show the content. */
	elseif ( current_user_can( 'administrator') )
		return do_shortcode($content);

	/* If there is no content, return nothing. */
	elseif ( is_null( $content ) )
		return '';

	/* Return nothing if none of the conditions have been met. */
	
	return '';
}

function free_members_access_check_shortcode( $attr, $content = null ) {
	if ( current_user_can( 'subscriber' ) )
		return do_shortcode($content);

	/* If there is no content, return nothing. */
	elseif ( is_null( $content ) )
		return '';

	/* Return nothing if none of the conditions have been met. */
	
	return '';
}

function cbwpm_options_init(){
	register_setting( 'cbwpm_options_options', 'cbm_data', 'cbwpm_options_validate' );
}

// Add menu page
function cbwpm_options_add_page() {
	add_options_page('CBWP Members Options', 'CBWP Members', 'manage_options', 'cbwpm_options', 'cbwpm_options_do_page');
}

// Draw the menu page itself
function cbwpm_options_do_page() {
	?>
	<div class="wrap">
		<h2>Membership Plugin Options</h2>
		<form method="post" action="options.php">
			<?php settings_fields('cbwpm_options_options'); ?>
			<?php $options = get_option('cbm_data'); ?>
			<table class="form-table">
				<tr valign="top"><th scope="row">Clickbank Account name</th>
					<td><input name="cbm_data[clickbankname]" type="text" value="<?php echo $options['clickbankname']; ?>" /></td>
				</tr>
				<tr valign="top"><th scope="row">Clickbank item number</th>
					<td><input type="text" name="cbm_data[cbitemno]" value="<?php echo $options['cbitemno']; ?>" /></td>
				</tr>
			<tr valign="top"><th scope="row">Link to Pitch Page</th>
					<td><input type="text" name="cbm_data[cbpitchpage]" value="<?php echo $options['cbpitchpage']; ?>" /></td>
				</tr>
				<tr valign="top"><th scope="row">Description of paid membership (eg; a paid member or a gold member)</th>
					<td><input type="text" name="cbm_data[cbmemdesc]" value="<?php echo $options['cbmemdesc']; ?>" /></td>
				</tr>
			
			</table>
			
			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>
	</div>
	<?php	
}

// Sanitize and validate input. Accepts an array, return a sanitized array.
function cbwpm_options_validate($input) {
	
	// Say our second option must be safe text with no HTML tags
	$input['clickbankname'] =  wp_filter_nohtml_kses($input['clickbankname']);
	$input['cbitemno'] =  wp_filter_nohtml_kses($input['cbitemno']);
	$input['cbpitchpage'] =  wp_filter_nohtml_kses($input['cbpitchpage']);
	$input['cbmemdesc'] =  wp_filter_nohtml_kses($input['cbmemdesc']);
	return $input;
}


?>